/*
 * NamedSequence.cpp
 *
 *  Created on: Apr 15, 2010
 *      Author: Oleksiy Kohany <kohany@gmail.com>
 */

#include "NamedSequence.h"
#include <sstream>
#include <iostream>
using namespace std;

namespace bio {

   NamedSequence::NamedSequence() {
   }
   NamedSequence::NamedSequence(const NamedSequence& other) :
      Sequence(other), name(other.getName()) {
   }
   NamedSequence::NamedSequence(const string& name, const string& data) : Sequence(data), name(name) {
   }
   NamedSequence::~NamedSequence() {
   }
   void NamedSequence::readFAHeaderLine(const string& s) {
      if(!s.empty() && s[0] == '>') {
         istringstream iss(s.c_str() + 1);
         iss >> name;
      }
   }
   void NamedSequence::readIGHeaderLine(const string& s) {
      if(!s.empty() && s[0] != ';') {
         name = s;
      }
   }
   void NamedSequence::printFAHeader(ostream& os, const char* comment) const {
      os << ">" << name;
      if(comment) {
         os << "\t" << comment;
      }
      os << endl;
   }
   void NamedSequence::printIGHeader(ostream& os, const char* comment) const {
      if(comment) {
         os << "; " << comment << "\n";
      }
      os << "; \n" << name << endl;
   }
}
